Index: trunk/zoo-project/zoo-kernel/service_internal_r.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_r.c	(revision 917)
+++ trunk/zoo-project/zoo-kernel/service_internal_r.c	(revision 917)
@@ -0,0 +1,394 @@
+/*
+ * Author : Gérald FENOY
+ *
+ * Copyright (c) 2018 GeoLabs SARL
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+#include "service_internal_r.h"
+
+void jump_to_toplevel(void){
+  fprintf(stderr,"Error occured\n");
+  fprintf(stderr,"%s %d \n",__FILE__,__LINE__);
+  fflush(stderr);
+  //resetStack(1);
+  fprintf(stderr,"%s %d \n",__FILE__,__LINE__);
+  fflush(stderr);
+}
+
+void init_zoo(SEXP conf,SEXP outputs){
+  const char* names[]={
+    "SERVICE_SUCCEEDEED",
+    "SERVICE_FAILED",
+    "conf",
+    "outputs",
+    ""
+  };
+  SEXP res = PROTECT(mkNamed(VECSXP, names));
+  SET_VECTOR_ELT(res, 0, Rf_ScalarInteger(3));
+  SET_VECTOR_ELT(res, 1, Rf_ScalarInteger(4));
+  SET_VECTOR_ELT(res, 2, conf);
+  SET_VECTOR_ELT(res, 3, outputs);
+  defineVar(install("zoo"),res, R_GlobalEnv);
+
+  static const R_CallMethodDef callMethods[]  = {
+    {"ZOOTranslate", (DL_FUNC) &RTranslate, 1},
+    {"ZOOUpdateStatus", (DL_FUNC) &RUpdateStatus, 2},
+    {NULL, NULL, 0}
+  };
+  
+  static R_NativePrimitiveArgType RTranslate_t[] = {
+    STRSXP
+  };
+  static R_NativePrimitiveArgType RUpdateStatus_t[] = {
+    VECSXP,STRSXP
+  };
+  
+  static const R_CMethodDef cMethods[] = {
+   {"ZOOTranslate", (DL_FUNC) &RTranslate, 1, RTranslate_t},
+   {"ZOOUpdateStatus", (DL_FUNC) &RUpdateStatus, 2, RUpdateStatus_t},
+   {NULL, NULL, 0, NULL}
+  };
+  
+  DllInfo *info = R_getEmbeddingDllInfo();
+  R_registerRoutines(info, cMethods, callMethods, NULL, NULL);
+}
+
+/**
+ * Load a R script then run the function corresponding to the service
+ * by passing the conf, inputs and outputs parameters by reference. 
+ *
+ * @param main_conf the conf maps containing the main.cfg settings
+ * @param request the map containing the HTTP request
+ * @param s the service structure
+ * @param real_inputs the maps containing the inputs
+ * @param real_outputs the maps containing the outputs
+ */
+int zoo_r_support(maps** main_conf,map* request,service* s,maps **real_inputs,maps **real_outputs){
+  SEXP pName;
+  int result=0;
+  maps* m=*main_conf;
+  maps* inputs=*real_inputs;
+  maps* outputs=*real_outputs;
+  map* tmp0=getMapFromMaps(*main_conf,"lenv","cwd");
+  char *ntmp=tmp0->value;
+  map* tmp=NULL;
+  int hasToClean=0;
+  char *r_path, *rpath;
+  map* cwdMap=getMapFromMaps(*main_conf,"main","servicePath");
+  int r_argc = 3;
+  char *r_argv[] = { "R", "--no-save", "--silent" };
+  Rf_initEmbeddedR(r_argc, r_argv);
+  if(cwdMap!=NULL)
+    r_path=cwdMap->value;
+  else{
+    if(tmp0!=NULL)
+      r_path=tmp0->value;
+    else
+      r_path=(char*)".";
+  }
+
+  tmp=getMap(s->content,"serviceProvider");
+  map* mp=getMap(request,"metapath");
+  if(tmp!=NULL){
+    if(mp!=NULL && strlen(mp->value)>0){
+      char *mn=(char*)malloc((strlen(mp->value)+strlen(tmp->value)+2)*sizeof(char));
+      sprintf(mn,"%s/%s",mp->value,tmp->value);
+      pName = mkString(mn);
+      free(mn);
+    }
+    else{
+      char *tmpStr=(char*)malloc((strlen(r_path)+strlen(tmp->value)+2)*sizeof(char));
+      sprintf(tmpStr,"%s/%s",r_path,tmp->value);
+      pName = mkString(tmpStr);
+      free(tmpStr);
+    }
+  }
+  else{
+    errorException (m, "Unable to parse serviceProvider please check your zcfg file.", "NoApplicableCode", NULL);
+    return -1;
+  }
+  SEXP e;
+  int errorOccurred;
+  PROTECT(e = lang2(install("source"), pName));
+  R_tryEval(e, R_GlobalEnv, &errorOccurred);
+  UNPROTECT(1);
+  if (errorOccurred){
+    setMapInMaps(*main_conf,"lenv","message",_("Unable to load your R file"));
+    return SERVICE_FAILED;
+  }else{
+    result=SERVICE_FAILED;
+    {
+      SEXP pValue;
+      SEXP  arg1=RList_FromMaps(m);
+      SEXP  arg2=RList_FromMaps(*real_inputs);
+      SEXP  arg3=RList_FromMaps(*real_outputs);
+      SEXP r_call;
+      init_zoo(arg1,arg3);
+      PROTECT(r_call = lang4(install(s->name), arg1,arg2,arg3));
+      int errorOccurred;
+      
+      SEXP ret = R_tryEval(r_call, R_GlobalEnv, &errorOccurred);
+      if (!errorOccurred) {
+	int *val = INTEGER(ret);
+        for (int i = 0; i < LENGTH(ret); i++)
+	  if(i==0){
+	      result=val[i];
+	      SEXP zooEnv = findVar(install("zoo"), R_GlobalEnv);
+	      if(zooEnv!=NULL){
+		SEXP names = Rf_getAttrib(zooEnv, R_NamesSymbol);
+		int nbKeys=nrows(names);
+		int i;
+		for(i=0;i<nbKeys;i++){
+		  if(i==2){
+		    freeMaps(main_conf);
+		    free(*main_conf);
+		    SEXP confList=VECTOR_ELT(zooEnv,i);
+		    *main_conf=mapsFromRList(confList);
+		  }
+		  if(i==3){
+		    freeMaps(real_outputs);
+		    free(*real_outputs);
+		    SEXP outList=VECTOR_ELT(zooEnv,i);
+		    *real_outputs=mapsFromRList(outList);
+		  }
+		}
+	      }
+	      return result;
+	    }
+      }else{
+	const char* tmpStr=R_curErrorBuf();
+	setMapInMaps(*main_conf,"lenv","message",tmpStr);
+	char* finalStr=(char*)malloc((strlen(tmpStr)+strlen(_("Unable to run your R service: "))+2)*sizeof(char));
+	sprintf(finalStr,"%s %s",_("Unable to run your R service: "),tmpStr);
+	errorException(*main_conf,finalStr,"NoApplicableCode",NULL);
+	free(finalStr);
+	result=-1;
+      }
+    }
+  }
+  Rf_endEmbeddedR(0);
+  return result;
+}
+
+char** listMapsKeys(maps* m){
+  char** res=NULL;
+  maps* tmp=m;
+  int i=0;
+  while(tmp!=NULL){
+    if(i==0)
+      res=(char**)malloc(2*sizeof(char*));
+    else
+      res=(char**)realloc(res,(i+2)*sizeof(char*));
+    res[i]=zStrdup(tmp->name);
+    res[i+1]="";
+    i++;
+    tmp=tmp->next;
+  }
+  return res;
+}
+
+char** listMapKeys(map* m){
+  char** res=NULL;
+  map* tmp=m;
+  int i=0;
+  while(tmp!=NULL){
+    if(i==0)
+      res=(char**)malloc(2*sizeof(char*));
+    else
+      res=(char**)realloc(res,(i+2)*sizeof(char*));
+    res[i]=zStrdup(tmp->name);
+    res[i+1]="";
+    i++;
+    tmp=tmp->next;
+  }
+  return res;
+}
+
+/**
+ * Convert a maps to a R List
+ *
+ * @param t the maps to convert
+ * @return a new SEXP containing the converted maps
+ * @see RList_FromMap
+ * @warning make sure to free resources returned by this function
+ */
+SEXP RList_FromMaps(maps* t){
+  maps* tmp=t;
+  char** keys=listMapsKeys(t);
+  SEXP res = PROTECT(mkNamed(VECSXP,(const char**) keys));
+  free(keys);
+  int cnt=0;
+  while(tmp!=NULL){
+    SEXP input = RList_FromMap(tmp->content);
+    SET_VECTOR_ELT(res,cnt,input);
+    cnt++;
+    tmp=tmp->next;
+  } 
+  UNPROTECT(1);
+  return res;
+}
+
+/**
+ * Convert a map to a R List
+ *
+ * @param t the map to convert
+ * @return a new SEXP containing the converted maps
+ * @warning make sure to free resources returned by this function
+ */
+SEXP RList_FromMap(map* t){
+  map* tmp=t;
+  int hasSize=0;
+  char** keys=listMapKeys(t);
+  SEXP res = PROTECT(mkNamed(VECSXP, (const char**)keys));
+  free(keys);
+  int cnt=0;
+  while(tmp!=NULL){
+    SEXP value=mkString(tmp->value);
+    SET_VECTOR_ELT(res,cnt,value);
+    cnt++;
+    tmp=tmp->next;
+  }
+  UNPROTECT(1);
+  return res;
+}
+
+/**
+ * Convert a R List to a maps 
+ *
+ * @param t the PyDictObject to convert
+ * @return a new maps containing the converted PyDictObject
+ * @warning make sure to free resources returned by this function
+ */
+maps* mapsFromRList(SEXP t){
+  maps* res=NULL;
+  maps* cursor=NULL;
+  SEXP names = Rf_getAttrib(t, R_NamesSymbol);
+  int nbKeys=nrows(names);
+  int i;
+  for(i=0;i<nbKeys;i++){
+    SEXP key=STRING_ELT(names,i);
+    SEXP value=VECTOR_ELT(t,i);
+    cursor=createMaps(R_CHAR(key));
+    cursor->content=mapFromRList(value);
+    cursor->next=NULL;
+    if(res==NULL)
+      res=dupMaps(&cursor);
+    else
+      addMapsToMaps(&res,cursor);
+    freeMap(&cursor->content);
+    free(cursor->content);
+    free(cursor);
+  }
+  return res;
+}
+
+/**
+ * Convert a R List to a map 
+ *
+ * @param t the PyDictObject to convert
+ * @return a new map containing the converted PyDictObject
+ * @warning make sure to free resources returned by this function
+ */
+map* mapFromRList(SEXP t){
+  map* res=NULL;
+  SEXP names = Rf_getAttrib(t, R_NamesSymbol);
+  int nbKeys=nrows(names);
+  int i;
+  for(i=0;i<nbKeys;i++){
+    SEXP key=STRING_ELT(names,i);
+    SEXP value=VECTOR_ELT(t,i);
+    if(strncmp(R_CHAR(key),"child",5)!=0){
+      {
+	const char* lkey=R_CHAR(key);
+	const char* lvalue=CHAR(STRING_ELT(value,0));
+	if(res!=NULL){
+	  addToMap(res,lkey,lvalue);
+	}
+	else{
+	  res=createMap(lkey,lvalue);
+	}
+      }
+    }
+  }
+  return res;
+}
+
+/**
+ * Use the ZOO-Services messages translation function from the R
+ * environment
+ *
+ * @param str the R string passed from the R environment
+ * @return a new R string containing the translated value
+ * @see _ss
+ */
+SEXP
+RTranslate(SEXP str)
+{
+  if (!isString(str) || !TYPEOF(STRING_ELT( str, 0 )) == CHARSXP){
+#ifdef DEBUG
+    fprintf(stderr,"Incorrect arguments to update status function");
+#endif
+    return R_NilValue;
+  }
+  const char* tmpStr=CHAR(STRING_ELT(str,0));
+  return mkString(_ss(tmpStr));
+}
+
+/**
+ * Update the ongoing status of a running service from the R environment
+ *
+ * @param confdict the R arguments passed from the R environment
+ * @param status the R arguments passed from the R environment
+ * @return Nil to the Python environment
+ * @see _updateStatus
+ */
+SEXP
+RUpdateStatus(SEXP confdict,SEXP status)
+{
+  maps* conf;
+  int istatus;
+  char* cstatus=NULL;
+  if (!isInteger(status) && !isReal(status)){
+#ifdef DEBUG
+    fprintf(stderr,"Incorrect arguments to update status function");
+#endif
+    return R_NilValue;
+  }
+  if(isInteger(status))
+    istatus=asInteger(status);
+  else
+    istatus=asReal(status);
+  if (istatus < 0 || istatus > 100){
+    return R_NilValue;
+  }
+  // create a local copy and update the lenv map
+  conf = mapsFromRList(confdict);
+  if(status!=NULL){
+    maps* tmpMaps=getMaps(conf,"lenv");
+    addIntToMap(tmpMaps->content,"status",istatus);
+  }
+  else
+    setMapInMaps(conf,"lenv","status","15");
+  _updateStatus(conf);
+  freeMaps(&conf);
+  free(conf);
+  return R_NilValue;
+}
Index: trunk/zoo-project/zoo-kernel/service_internal_r.h
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_r.h	(revision 917)
+++ trunk/zoo-project/zoo-kernel/service_internal_r.h	(revision 917)
@@ -0,0 +1,47 @@
+/*
+ * Author : Gérald FENOY
+ *
+ * Copyright (c) 2009-2010 GeoLabs SARL
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+#ifndef ZOO_SERVICE_INTERNAL_R_H
+#define ZOO_SERVICE_INTERNAL_R_H 1
+
+#pragma once 
+
+#include <Rinternals.h>
+#include <Rembedded.h>
+#include "service_internal.h"
+#include "response_print.h"
+#include "cgic.h"
+
+SEXP RList_FromMaps(maps* t);
+SEXP RList_FromMap(map* t);
+
+maps* mapsFromRList(SEXP t);
+map* mapFromRList(SEXP t);
+
+int zoo_r_support(maps**,map*,service*,maps**,maps**);
+
+SEXP RTranslate(SEXP);
+SEXP RUpdateStatus(SEXP,SEXP);
+
+#endif
Index: trunk/zoo-project/zoo-kernel/service_internal_ruby.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_ruby.c	(revision 889)
+++ trunk/zoo-project/zoo-kernel/service_internal_ruby.c	(revision 917)
@@ -260,4 +260,5 @@
   int hasSize=0;
   map* isArray=getMap(tmp,"isArray");
+  map* useFile=getMap(tmp,"use_file");
   map* size=getMap(tmp,"size");
   map* tmap=getMapType(tmp);
@@ -271,4 +272,5 @@
 	VALUE mvalue=rb_ary_new2(cnt);
 	VALUE svalue=rb_ary_new2(cnt);
+	VALUE cvalue=rb_ary_new2(cnt);
 
 	for(int i=0;i<cnt;i++){
@@ -276,4 +278,6 @@
 	  map* vMap=getMapArray(tmp,"value",i);	    
 	  map* sMap=getMapArray(tmp,"size",i);
+	  map* uMap=getMapArray(tmp,"use_file",i);
+	  map* cMap=getMapArray(tmp,"cache_file",i);
 
 	  if(vMap!=NULL){
@@ -281,7 +285,11 @@
 	    VALUE lvalue;
 	    VALUE lsvalue;
-	    if(sMap==NULL){
+	    VALUE lcvalue;
+	    if(sMap==NULL || uMap==NULL){
 	      lvalue=rb_str_new2(vMap->value);
-	      lsvalue=Qnil;
+	      if(sMap==NULL)
+		lsvalue=Qnil;
+	      else
+		lsvalue=rb_str_new2(sMap->value);
 	    }
 	    else{
@@ -290,7 +298,12 @@
 	      hasSize=1;
 	    }
+	    if(uMap!=NULL)
+	      lcvalue=rb_str_new2(cMap->value);
+	    else
+	      lcvalue=Qnil;
 
 	    rb_ary_push(value,lvalue);
 	    rb_ary_push(svalue,lsvalue);
+	    rb_ary_push(cvalue,lcvalue);
 	  }
 	  
@@ -308,4 +321,6 @@
 	rb_hash_aset(res, name, mvalue);
 	rb_hash_aset(res, rb_str_new2(tmap->name), mvalue);
+	VALUE lname0=rb_str_new2("cache_size");
+	rb_hash_aset(res, lname0, value);
       
 	if(hasSize>0){
Index: trunk/zoo-project/zoo-kernel/service_internal_saga.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_saga.c	(revision 889)
+++ trunk/zoo-project/zoo-kernel/service_internal_saga.c	(revision 917)
@@ -30,5 +30,5 @@
 #include <api_core.h>
 #include <data_manager.h>
-#include <module_library.h>
+#include <saga_api.h>
 #define _ZOO_SAGA
 #include "service_internal_saga.h"
@@ -237,5 +237,7 @@
 	return false;
       }
-      return( param->Set_Value(SG_Get_Data_Manager().Find(&fileName)) );
+      fprintf(stderr,"%s %s\n",carg->name,carg->value);
+      fflush(stderr);
+      return( param->Set_Value(SG_Get_Data_Manager().Find(&fileName,false)) );
     }
     else
@@ -250,5 +252,5 @@
 	    SG_Get_Data_Manager().Add(&fileName);
 	  }
-	  param->asList()->Add_Item(SG_Get_Data_Manager().Find(&fileName));
+	  param->asList()->Add_Item(SG_Get_Data_Manager().Find(&fileName,false));
 	}
       }
@@ -327,8 +329,16 @@
 	    inmap=getMap(argument,(CSG_String(param->Get_Identifier())+"_MIN").b_str());
 	    if(inmap!=NULL)
+#if SAGA_MAJOR_VERSION == 2	      
 	      param->asRange()->Set_LoVal(strtod(inmap->value,NULL));
+#else
+	      param->asRange()->Set_Min(strtod(inmap->value,NULL));
+#endif	    
 	    inmap=getMap(argument,(CSG_String(param->Get_Identifier())+"_MAX").b_str());
 	    if(inmap!=NULL)
+#if SAGA_MAJOR_VERSION == 2	      
 	      param->asRange()->Set_HiVal(strtod(inmap->value,NULL));	    
+#else
+	      param->asRange()->Set_Max(strtod(inmap->value,NULL));
+#endif	    
 	  }
 	  if(inmap==NULL){
@@ -386,7 +396,19 @@
 	    else if( param->is_DataObject_List() )
 	      {
-		for(int i=0; i<param->asList()->Get_Count(); i++)
+		for(int i=0; i<
+#if SAGA_MAJOR_VERSION == 2
+		      param->asList()->Get_Count()
+#else
+		      param->asList()->Get_Data_Count()
+#endif		      
+		      ; i++)
 		  {
-		    CSG_Data_Object *pObject = param->asList()->asDataObject(i);
+		    CSG_Data_Object *pObject =
+#if SAGA_MAJOR_VERSION == 2		      
+		      param->asList()->asDataObject(i)
+#else
+		      param->asList()->Get_Data(i)
+#endif		      
+		      ;
 		    
 		    if( pObject->is_Modified() && SG_File_Exists(pObject->Get_File_Name()) )
@@ -439,5 +461,5 @@
 			}
 		    }
-		  
+#if SAGA_MAJOR_VERSION == 2		  
 		  int nFileNames = param->asList()->Get_Count() <= fileNames.Get_Count() ? fileNames.Get_Count() : fileNames.Get_Count() - 1;
 		  for(int i=0; i<param->asList()->Get_Count(); i++)
@@ -458,4 +480,25 @@
 				  CSG_String(param->asList()->asDataObject(i)->Get_File_Name()).b_str());
 		    }
+#else
+		  int nFileNames = param->asList()->Get_Data_Count() <= fileNames.Get_Count() ? fileNames.Get_Count() : fileNames.Get_Count() - 1;
+		  for(int i=0; i<param->asList()->Get_Data_Count(); i++)
+		    {
+		      if( i < nFileNames )
+			{
+			  param->asList()->Get_Data(i)->Save(fileNames[i]);
+			}
+		      else
+			{
+			  param->asList()->Get_Data(i)->Save(CSG_String::Format(SG_T("%s_%0*d"),
+										    fileNames[fileNames.Get_Count() - 1].c_str(),
+										    SG_Get_Digit_Count(param->asList()->Get_Data_Count()),
+										    1 + i - nFileNames
+										    ));
+			}
+		      setMapArray(cMaps->content,"generated_file",i,
+				  CSG_String(param->asList()->Get_Data(i)->Get_File_Name()).b_str());
+		    }
+		  
+#endif		  
 		}
 	    }
@@ -477,5 +520,9 @@
   int res=SERVICE_FAILED;
 
+#if SAGA_MAJOR_VERSION == 2  
   CSG_Module_Library * library=SG_Get_Module_Library_Manager().Get_Library(CSG_String(lib_name),true);
+#else
+  CSG_Tool_Library * library=SG_Get_Tool_Library_Manager().Get_Library(CSG_String(lib_name),true);
+#endif  
   if( library == NULL){
     char tmp[255];
@@ -486,5 +533,9 @@
   }
 
+#if SAGA_MAJOR_VERSION == 2  
   CSG_Module * module=library->Get_Module(atoi(module_name));
+#else
+  CSG_Tool * module=library->Get_Tool(atoi(module_name));
+#endif  
   if(module == NULL){
     char tmp[255];
@@ -985,6 +1036,12 @@
   SG_Set_UI_Callback(Get_Callback(watcher));
 
+#if SAGA_MAJOR_VERSION == 2  
   int n = SG_Get_Module_Library_Manager().Add_Directory(wxT(MODULE_LIBRARY_PATH),false);
-  if( SG_Get_Module_Library_Manager().Get_Count() <= 0 ){
+  if( SG_Get_Module_Library_Manager().Get_Count() <= 0 )
+#else
+  int n = SG_Get_Tool_Library_Manager().Add_Directory(wxT(MODULE_LIBRARY_PATH),false);
+  if( SG_Get_Tool_Library_Manager().Get_Count() <= 0 )
+#endif
+  {
     setMapInMaps(*main_conf,"lenv","message","Could not load any SAGA tool library");
     res=SERVICE_FAILED;
@@ -995,5 +1052,9 @@
 
   // Load the SAGA-GIS library corresponding to the serviceProvider
+#if SAGA_MAJOR_VERSION == 2  
   CSG_Module_Library * library=SG_Get_Module_Library_Manager().Get_Library(CSG_String(serviceProvider->value),true);
+#else
+  CSG_Tool_Library * library=SG_Get_Tool_Library_Manager().Get_Library(CSG_String(serviceProvider->value),true);
+#endif
   if( library == NULL){
     char tmp[255];
@@ -1005,5 +1066,9 @@
   
   // Load the SAGA-GIS module corresponding to the service name from the library
+#if SAGA_MAJOR_VERSION == 2  
   CSG_Module * module=library->Get_Module(atoi(s->name));
+#else
+  CSG_Tool * module=library->Get_Tool(atoi(s->name));
+#endif
   if(module == NULL){
     char tmp[255];
@@ -1017,5 +1082,4 @@
   // Load all the parameters defined for the module
   CSG_Parameters * params=module->Get_Parameters();
-  int pc=params->Get_Count();
   if(!params){
     char tmp[255];
@@ -1026,4 +1090,5 @@
     return res;
   }
+  int pc=params->Get_Count();
 
   // Loop over each inputs to transform raster files to grid when needed, 
Index: trunk/zoo-project/zoo-kernel/service_json.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_json.c	(revision 917)
+++ trunk/zoo-project/zoo-kernel/service_json.c	(revision 917)
@@ -0,0 +1,143 @@
+/*
+ * Author : Gérald FENOY
+ *
+ *  Copyright 2017 GeoLabs SARL. All rights reserved.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+#include "service_json.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+  json_object* mapToJson(map* myMap){
+    json_object *res=json_object_new_object();
+    map* cursor=myMap;
+    map* sizeMap=getMap(myMap,"size");
+    map* length=getMap(myMap,"length");
+    while(cursor!=NULL){
+      json_object *val=NULL;
+      if(length==NULL && sizeMap==NULL)
+	val=json_object_new_string(cursor->value);
+      else{
+	if(length==NULL && sizeMap!=NULL){
+	  if(strncasecmp(cursor->name,"value",5)==0)
+	    val=json_object_new_string_len(cursor->value,atoi(sizeMap->value));
+	  else
+	    val=json_object_new_string(cursor->value);
+	}
+	else{
+	  // In other case we should consider array with potential sizes
+	  int limit=atoi(length->value);
+	  int i=0;
+	  val=json_object_new_array();
+	  for(i=0;i<limit;i++){
+	    map* lsizeMap=getMapArray(myMap,"size",i);
+	    if(lsizeMap!=NULL && strncasecmp(cursor->name,"value",5)==0){
+	      json_object_array_add(val,json_object_new_string_len(cursor->value,atoi(sizeMap->value)));
+	    }else{
+	      json_object_array_add(val,json_object_new_string(cursor->value));
+	    }
+	  }
+	}
+      }
+      if(val!=NULL)
+	json_object_object_add(res,cursor->name,val);
+      cursor=cursor->next;
+    }
+    return res;
+  }
+
+  json_object* mapsToJson(maps* myMap){
+    json_object *res=json_object_new_object();
+    maps* cursor=myMap;
+    while(cursor!=NULL){
+      json_object *obj=NULL;
+      if(cursor->content!=NULL){
+	//json_object *content=NULL;
+	obj=mapToJson(cursor->content);
+	//json_object_object_add(obj,"content",content);
+      }else
+	obj=json_object_new_object();
+      if(cursor->child!=NULL){
+	json_object *child=NULL;
+	child=mapsToJson(cursor->child);
+	json_object_object_add(obj,"child",child);
+      }
+      json_object_object_add(res,cursor->name,obj);
+      cursor=cursor->next;
+    }
+    return res;
+  }
+
+  json_object* elementsToJson(elements* myElements){
+    json_object *res=json_object_new_object();
+    elements* cur=myElements;
+    while(cur!=NULL){
+      json_object *cres=json_object_new_object();
+      json_object_object_add(cres,"content",mapToJson(cur->content));
+      json_object_object_add(cres,"metadata",mapToJson(cur->metadata));
+      json_object_object_add(cres,"additional_parameters",mapToJson(cur->additional_parameters));
+      if(cur->format!=NULL){
+	json_object_object_add(cres,"format",json_object_new_string(cur->format));
+      }
+      if(cur->child==NULL){
+	if(cur->defaults!=NULL)
+	  json_object_object_add(cres,"defaults",mapToJson(cur->defaults->content));
+	else
+	  json_object_object_add(cres,"defaults",mapToJson(NULL));
+	iotype* scur=cur->supported;
+	json_object *resi=json_object_new_array();
+	while(scur!=NULL){
+	  json_object_array_add(resi,mapToJson(scur->content));
+	  scur=scur->next;
+	}
+	json_object_object_add(cres,"supported",resi);
+	fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+	fflush(stderr);
+      }
+      
+      dumpElements(cur->child);
+      json_object_object_add(cres,"child",elementsToJson(cur->child));
+      fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+      fflush(stderr);
+
+      json_object_object_add(res,cur->name,cres);
+      cur=cur->next;
+    }
+    return res;
+  }
+  
+  json_object* serviceToJson(service* myService){
+    json_object *res=json_object_new_object();
+    json_object_object_add(res,"name",json_object_new_string(myService->name));
+    json_object_object_add(res,"content",mapToJson(myService->content));
+    json_object_object_add(res,"metadata",mapToJson(myService->metadata));
+    json_object_object_add(res,"additional_parameters",mapToJson(myService->additional_parameters));
+    json_object_object_add(res,"inputs",elementsToJson(myService->inputs));
+    json_object_object_add(res,"outputs",elementsToJson(myService->outputs));
+    return res;
+  }
+  
+  
+#ifdef __cplusplus
+}
+#endif
Index: trunk/zoo-project/zoo-kernel/service_json.h
===================================================================
--- trunk/zoo-project/zoo-kernel/service_json.h	(revision 917)
+++ trunk/zoo-project/zoo-kernel/service_json.h	(revision 917)
@@ -0,0 +1,44 @@
+/*
+ * Author : Gérald FENOY
+ *
+ *  Copyright 2014 GeoLabs SARL. All rights reserved.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+#ifndef ZOO_JSON_H
+#define ZOO_JSON_H 1
+
+#pragma once
+
+#include <stdio.h>
+#include <ctype.h>
+#include <service.h>
+#include <json_object.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+  json_object* mapToJson(map*);
+  json_object* mapsToJson(maps*);
+  json_object* serviceToJson(service*);
+#ifdef __cplusplus
+}
+#endif
+#endif
Index: trunk/zoo-project/zoo-kernel/service_yaml.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_yaml.c	(revision 889)
+++ trunk/zoo-project/zoo-kernel/service_yaml.c	(revision 917)
@@ -487,5 +487,5 @@
 	      addMapToIoType(&current_element->supported,current_content);
 	  }
-	  freeMaps(&current_content);
+	  freeMap(&current_content);
 	  free(current_content);
 	  current_content=NULL;
Index: trunk/zoo-project/zoo-kernel/sql/schema.sql
===================================================================
--- trunk/zoo-project/zoo-kernel/sql/schema.sql	(revision 889)
+++ trunk/zoo-project/zoo-kernel/sql/schema.sql	(revision 917)
@@ -31,6 +31,6 @@
 -- Create a dedicated schema to store all tables
 -- Uncomment the following 2 lines to activate the schema use
--- CREATE SCHEMA zoo;
--- SET search_path TO zoo;
+-- CREATE SCHEMA processdb;
+-- SET search_path TO processdb;
 --------------------------------------------------------------------------------
 -- Services table
